{-----------------------------------------------------------------}
{    -        }
{     16- ,   }
{        }
{                                               }
{-----------------------------------------------------------------}
{   -                            }
{  TMainWindow.wmTimer                                   }
{-----------------------------------------------------------------}

program Digit_IO;
Uses OWindows, ODialogs, WinTypes, WinProcs, BWCC, Strings,
   lcard_ad;

{$R digit_io.res }
{$I digit_io.inc }

Type
   TDemoApplication = object (TApplication)
      procedure InitMainWindow; virtual;
   end;

   PMainWindow = ^TMainWindow;
   TMainWindow = object(TDlgWindow)
      constructor Init(AParent: PWindowsObject);
      procedure   SetupWindow; virtual;
      destructor  Done; virtual;
      procedure   WmTimer(var Msg:TMessage); virtual wm_First + wm_Timer;
   end;

Var
   OutEd : PEdit;
   BitStArray: array [1..16] of PStatic;


{-----------------------------------------------------------------}
{ ,        .   }
{                                     }
{-----------------------------------------------------------------}

constructor TMainWindow.Init(AParent: PWindowsObject);
Var
   j : Integer;
begin
  inherited Init(AParent,MakeIntResource(id_MainDialog));
  OutEd:=New(PEdit, InitResource(@Self, id_OutEd, 17));
  for j:=1 to 16 do
     BitStArray[j]:=New(PStatic, InitResource(@Self, id_BitSt+(j-1),2));
end;

destructor TMainWindow.Done;
begin
   KillTimer(HWindow, id_Timer);
   inherited Done;
end;

procedure TMainWindow.SetupWindow;
begin
   inherited SetupWindow;
   SetTimer(HWindow, id_Timer, 200, nil);
end;


procedure TMainWindow.WmTimer;
Var
  P     : array [1..80] of char;
  S     : String;
  Error : Integer;
  iOut, iIn  : Word;
  j     : Integer;
  Bit   : Word;
  Channels, Data:array [1..16] of Integer;
begin
   OutEd^.GetText(@P, SizeOf(P));
   S:=StrPas(@P);

   iOut:=0;
   for j:=1 to Length(S) do
      begin
         iOut:=iOut*2;
         if S[j]='1' then iOut:=iOut+1;
      end;

   {    () iOut    }
   OUTBYTE(iOUT);

   {      }
   iIN:=INPBYTE;

   Bit:=1;
   for j:=1 to 16 do
      begin
         if (iIN and Bit)<>0 then
            BitStArray[j]^.SetText('1')
         else
            BitStArray[j]^.SetText('0');
         Bit:=Bit shl 1;
      end;
end;


{-----------------------------------------------------------------}
procedure TDemoApplication.InitMainWindow;
begin
   MainWindow:=new(PMainWindow, Init(Nil));
end;

var
   DemoApplication:TDemoApplication;
begin
   if PLATA_TEST<>0 then
      begin
         MessageBox(0, '     BIOS', '', MB_OK or MB_TASKMODAL or MB_ICONSTOP);
         exit;
      end;

   DemoApplication.Init('digit_io');
   DemoApplication.Run;
   DemoApplication.Done;
end.
