{-----------------------------------------------------------------}
{ :                         }
{-----------------------------------------------------------------}
{-----------------------------------------------------------------}


{        !!! }
{   ,   ,           }
{    : FIXED PRELOAD PERMANENT }
{    MOVEABLE DEMANDLOAD DISCARDABLE   }
{ !!!                                                           }
{$C FIXED PRELOAD PERMANENT }
program Interrupts;
Uses OWindows, ODialogs, WinTypes, WinProcs, BWCC, Strings,
   lcard_ad;

{$I interrup.inc }
{$R interrup.res }
Type
   TDemoApplication = object (TApplication)
      procedure InitMainWindow; virtual;
   end;

   PMainWindow = ^TMainWindow;
   TMainWindow = object(TDlgWindow)
      constructor Init(AParent: PWindowsObject);
      procedure   SetupWindow; virtual;
      procedure   WmTimer(var Msg:TMessage); virtual wm_First + wm_Timer;
      destructor  Done; virtual;
   end;

Var
   CounterSt : PStatic;

Const
   Counter:LongInt = 0;


{$F+ }
procedure Handler; interrupt;
{$F- }
begin
   Inc(Counter);
   RESET_IRQ;
{   CounterSt^.SetText('Hallo'); }
end;

{-----------------------------------------------------------------}
{ ,                            }
{                                    }
{-----------------------------------------------------------------}
constructor TMainWindow.Init(AParent: PWindowsObject);
begin
  inherited Init(AParent,MakeIntResource(id_MainDialog));
  CounterSt:=New(PStatic, InitResource(@Self, id_CounterSt,10));

  {   L154, L164  2 -  }
  {          1  }
  if GET_BOARD_TYPE in [L154, L164] then
     INIT_SIMPLE_INTR(1000,10,@Handler)
  else
     {        . }
     INIT_SIMPLE_INTR(10000,0,@Handler)
end;


procedure TMainWindow.SetupWindow;
begin
   inherited SetupWindow;
   SetTimer(HWindow, id_Timer, 100, nil);
end;

destructor TMainWindow.Done;
begin
   STOP_INTR;
   KillTimer(HWindow, id_Timer);
   inherited Done;
end;

procedure TMainWindow.WmTimer;
Var
   S: String;
   P: Array [1..32] of Char;
begin
   Str(Counter, S);
   StrPCopy(@P,S);
   CounterSt^.SetText(@P);
end;
{-----------------------------------------------------------------}
procedure TDemoApplication.InitMainWindow;
begin
   MainWindow:=new(PMainWindow, Init(Nil));
end;

var
   DemoApplication:TDemoApplication;
begin
   if PLATA_TEST<>0 then
      begin
         MessageBox(0, '     BIOS', '', MB_OK or MB_TASKMODAL or MB_ICONSTOP);
         exit;
      end;

   DemoApplication.Init('single_i');
   DemoApplication.Run;
   DemoApplication.Done;
end.
